"""autogenerated by genpy from eusebio/RobotStatus.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class RobotStatus(genpy.Message):
  _md5sum = "231b46bf4a23f1ab3eb360a24cb47432"
  _type = "eusebio/RobotStatus"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header

#Time stamp of the data
int32 hour     #Hour
int32 min      #Minute
int32 sec      #Second

# EUSEBIO ROBOT STATUS

string robotID		 #Robot identifier
float32 battery_level     #Level of the battery in volts

bool[] dig_robot_state  #Digital I/O vector in the robot

#Cinematic status
float32 lin_speed	  #Linear speed in m/sec
float32 ang_speed	  #Angular speed in rad/sec
bool position_calibrated  #Whether the global position of the robot is calibrated respect to the map or not
float32 xs #Global X coordinate in (m) of the steering axis
float32 ys #Global Y coordinate in (m) of the steering axis
float32 xc #Global X coordinate in (m) of the center
float32 yc #Global Y coordinate in (m) of the center
float32 theta #Global Orientation of the body robot in rad

#Control
bool[] dig_ctr_state  #Digital controls state vector
float32 ref_lin #Reference control signal for linear velocity
float32 ref_ang #Reference control signal for angular velocity

#Historic total
float32 total_distance_travelled #Distance travelled in meters
float32 total_working_time       #Total time in sec since booting agv_hospital ros node  	
float32 total_moving_time       #Total time in sec since booting agv_hospital ros node  	

#Historic partial
float32 partial_distance_travelled #Partial distance travelled in meters
float32 partial_working_time       #Partial time in sec since booting agv_hospital ros node  	
float32 partial_moving_time       #Partial time in sec since booting agv_hospital ros node  	





================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"""
  __slots__ = ['header','hour','min','sec','robotID','battery_level','dig_robot_state','lin_speed','ang_speed','position_calibrated','xs','ys','xc','yc','theta','dig_ctr_state','ref_lin','ref_ang','total_distance_travelled','total_working_time','total_moving_time','partial_distance_travelled','partial_working_time','partial_moving_time']
  _slot_types = ['std_msgs/Header','int32','int32','int32','string','float32','bool[]','float32','float32','bool','float32','float32','float32','float32','float32','bool[]','float32','float32','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,hour,min,sec,robotID,battery_level,dig_robot_state,lin_speed,ang_speed,position_calibrated,xs,ys,xc,yc,theta,dig_ctr_state,ref_lin,ref_ang,total_distance_travelled,total_working_time,total_moving_time,partial_distance_travelled,partial_working_time,partial_moving_time

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RobotStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.hour is None:
        self.hour = 0
      if self.min is None:
        self.min = 0
      if self.sec is None:
        self.sec = 0
      if self.robotID is None:
        self.robotID = ''
      if self.battery_level is None:
        self.battery_level = 0.
      if self.dig_robot_state is None:
        self.dig_robot_state = []
      if self.lin_speed is None:
        self.lin_speed = 0.
      if self.ang_speed is None:
        self.ang_speed = 0.
      if self.position_calibrated is None:
        self.position_calibrated = False
      if self.xs is None:
        self.xs = 0.
      if self.ys is None:
        self.ys = 0.
      if self.xc is None:
        self.xc = 0.
      if self.yc is None:
        self.yc = 0.
      if self.theta is None:
        self.theta = 0.
      if self.dig_ctr_state is None:
        self.dig_ctr_state = []
      if self.ref_lin is None:
        self.ref_lin = 0.
      if self.ref_ang is None:
        self.ref_ang = 0.
      if self.total_distance_travelled is None:
        self.total_distance_travelled = 0.
      if self.total_working_time is None:
        self.total_working_time = 0.
      if self.total_moving_time is None:
        self.total_moving_time = 0.
      if self.partial_distance_travelled is None:
        self.partial_distance_travelled = 0.
      if self.partial_working_time is None:
        self.partial_working_time = 0.
      if self.partial_moving_time is None:
        self.partial_moving_time = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.hour = 0
      self.min = 0
      self.sec = 0
      self.robotID = ''
      self.battery_level = 0.
      self.dig_robot_state = []
      self.lin_speed = 0.
      self.ang_speed = 0.
      self.position_calibrated = False
      self.xs = 0.
      self.ys = 0.
      self.xc = 0.
      self.yc = 0.
      self.theta = 0.
      self.dig_ctr_state = []
      self.ref_lin = 0.
      self.ref_ang = 0.
      self.total_distance_travelled = 0.
      self.total_working_time = 0.
      self.total_moving_time = 0.
      self.partial_distance_travelled = 0.
      self.partial_working_time = 0.
      self.partial_moving_time = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3i.pack(_x.hour, _x.min, _x.sec))
      _x = self.robotID
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_f.pack(self.battery_level))
      length = len(self.dig_robot_state)
      buff.write(_struct_I.pack(length))
      pattern = '<%sB'%length
      buff.write(struct.pack(pattern, *self.dig_robot_state))
      _x = self
      buff.write(_struct_2fB5f.pack(_x.lin_speed, _x.ang_speed, _x.position_calibrated, _x.xs, _x.ys, _x.xc, _x.yc, _x.theta))
      length = len(self.dig_ctr_state)
      buff.write(_struct_I.pack(length))
      pattern = '<%sB'%length
      buff.write(struct.pack(pattern, *self.dig_ctr_state))
      _x = self
      buff.write(_struct_8f.pack(_x.ref_lin, _x.ref_ang, _x.total_distance_travelled, _x.total_working_time, _x.total_moving_time, _x.partial_distance_travelled, _x.partial_working_time, _x.partial_moving_time))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.hour, _x.min, _x.sec,) = _struct_3i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.robotID = str[start:end].decode('utf-8')
      else:
        self.robotID = str[start:end]
      start = end
      end += 4
      (self.battery_level,) = _struct_f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sB'%length
      start = end
      end += struct.calcsize(pattern)
      self.dig_robot_state = struct.unpack(pattern, str[start:end])
      self.dig_robot_state = map(bool, self.dig_robot_state)
      _x = self
      start = end
      end += 29
      (_x.lin_speed, _x.ang_speed, _x.position_calibrated, _x.xs, _x.ys, _x.xc, _x.yc, _x.theta,) = _struct_2fB5f.unpack(str[start:end])
      self.position_calibrated = bool(self.position_calibrated)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sB'%length
      start = end
      end += struct.calcsize(pattern)
      self.dig_ctr_state = struct.unpack(pattern, str[start:end])
      self.dig_ctr_state = map(bool, self.dig_ctr_state)
      _x = self
      start = end
      end += 32
      (_x.ref_lin, _x.ref_ang, _x.total_distance_travelled, _x.total_working_time, _x.total_moving_time, _x.partial_distance_travelled, _x.partial_working_time, _x.partial_moving_time,) = _struct_8f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3i.pack(_x.hour, _x.min, _x.sec))
      _x = self.robotID
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_struct_f.pack(self.battery_level))
      length = len(self.dig_robot_state)
      buff.write(_struct_I.pack(length))
      pattern = '<%sB'%length
      buff.write(self.dig_robot_state.tostring())
      _x = self
      buff.write(_struct_2fB5f.pack(_x.lin_speed, _x.ang_speed, _x.position_calibrated, _x.xs, _x.ys, _x.xc, _x.yc, _x.theta))
      length = len(self.dig_ctr_state)
      buff.write(_struct_I.pack(length))
      pattern = '<%sB'%length
      buff.write(self.dig_ctr_state.tostring())
      _x = self
      buff.write(_struct_8f.pack(_x.ref_lin, _x.ref_ang, _x.total_distance_travelled, _x.total_working_time, _x.total_moving_time, _x.partial_distance_travelled, _x.partial_working_time, _x.partial_moving_time))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.hour, _x.min, _x.sec,) = _struct_3i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.robotID = str[start:end].decode('utf-8')
      else:
        self.robotID = str[start:end]
      start = end
      end += 4
      (self.battery_level,) = _struct_f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sB'%length
      start = end
      end += struct.calcsize(pattern)
      self.dig_robot_state = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=length)
      self.dig_robot_state = map(bool, self.dig_robot_state)
      _x = self
      start = end
      end += 29
      (_x.lin_speed, _x.ang_speed, _x.position_calibrated, _x.xs, _x.ys, _x.xc, _x.yc, _x.theta,) = _struct_2fB5f.unpack(str[start:end])
      self.position_calibrated = bool(self.position_calibrated)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sB'%length
      start = end
      end += struct.calcsize(pattern)
      self.dig_ctr_state = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=length)
      self.dig_ctr_state = map(bool, self.dig_ctr_state)
      _x = self
      start = end
      end += 32
      (_x.ref_lin, _x.ref_ang, _x.total_distance_travelled, _x.total_working_time, _x.total_moving_time, _x.partial_distance_travelled, _x.partial_working_time, _x.partial_moving_time,) = _struct_8f.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_2fB5f = struct.Struct("<2fB5f")
_struct_8f = struct.Struct("<8f")
_struct_3i = struct.Struct("<3i")
_struct_f = struct.Struct("<f")
