/***************************************************************************
 *   Copyright (C) 2009 by Jaime Pulido y Salvador DomÃ­nguez   *
 *   saldom@cartif.es   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#include "gpmrc_node.h"


int main(int argc, char **argv)
{
  const char *serial_port_str= "/dev/ttyUSB0";
  int baud=38400;
  int i, q;

  for (i=1;i<argc;i++)
  {
        if((!strcmp(argv[i],"-port")) &&(argc>(i+1)) ) serial_port_str=argv[i+1];
        else if((!strcmp(argv[i],"-baud")) &&(argc>(i+1)) ) baud=atoi(argv[i+1]);
        else if (!strcmp(argv[i],"-help")){
		//g_print("-port <dispositivo serie> 	Dispositivo de comunicación con el cabezal /dev/tts/USB* \n");
                printf("-port  <serial_port>\n");
                printf("-baud  <baud>\n");
                printf("-f  <configuration_file.yaml>\n");
                printf("-help 		Esta ayuda\n");
		return 0;
        }else if (!strcmp(argv[i],"-f")){
      }
  }

  serial_port= new LightweightSerial((char *)serial_port_str,baud,NULL);

  if (serial_port->happy==true){
    printf("Port:%s Opened. %d baud, 8 dat, NP\n",serial_port_str,baud);
    ID_RequestHnd ();
  }else{
      printf("Couln't open serial port %s . Exiting",serial_port_str);
    return -1;
  }

  ros::init(argc, argv, "gpmrc6_eusebio");
  ros::NodeHandle nh;

  ROS_DEBUG("GPMRC serial_port_str = [%s]", serial_port_str);
  ROS_INFO("Starting gpmrc node");

  //Publishing
  pub_gpmrc_state = nh.advertise<gpmrc_node::gpmrc_state>("/gpmrc/state", 100);

  //Subscribing
  ros::Subscriber mov_axes_sub=nh.subscribe<gpmrc_node::gpmrc_command> ("/gpmrc/command", 1, CommandHnd);

  printf("FIRMWARE VERSION: GPMRC6_EUSEBIO\n");
  ros_gpmrc_state.contr_name="GPMRC6_EUSEBIO";

  printf("NUMBER OF FUNCIONALITIES:%d\n",NUM_FUNCTIONALITIES);
  ros_gpmrc_state.num_funcs=(int8_t)NUM_FUNCTIONALITIES;

  ros_gpmrc_state.func_str.clear();

  ros_gpmrc_state.volt_active=true;
  ros_gpmrc_state.func_str.push_back("VLT");
  ros_gpmrc_state.joy_active=true;
  ros_gpmrc_state.func_str.push_back("JOY");
  ros_gpmrc_state.mot_active=true;
  ros_gpmrc_state.func_str.push_back("MOT");
  ros_gpmrc_state.com1_active=true;
  ros_gpmrc_state.func_str.push_back("PC1");
  ros_gpmrc_state.alrm_active=true;
  ros_gpmrc_state.func_str.push_back("AL_");
  ros_gpmrc_state.son_active=true;
  ros_gpmrc_state.func_str.push_back("SON");
  ros_gpmrc_state.bmp_active=true;
  ros_gpmrc_state.func_str.push_back("BMP");

  ros_gpmrc_state.joy_src=0;

  boost::thread thread_serial(ReceiveSerial);

  //boost::thread thread_ROS(ReceiveROS);
  //thread_ROS.join();
  ReceiveROS();

  thread_serial.interrupt();
  thread_serial.join();

  return 0;
}


